Bootstrap

牛客小白月赛101

比赛链接

https://ac.nowcoder.com/acm/contest/90072

A题 tb的区间问题

思路

实际上是求长度为 n − k n-k nk的区间的和的最大值。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 2e5 + 5;
int n, k;
int a[N], sum[N];
void solve()
{
    cin >> n >> k;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        sum[i] = sum[i - 1] + a[i];
    }
    int ans = 0;
    int len = n - k;
    for (int i = 1; i + len - 1 <= n; i++)
    {
        int j = i + len - 1;
        ans = max(ans, sum[j] - sum[i - 1]);
    }
    cout << ans << endl;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    // cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}

B题 tb的字符串问题

思路

用栈从前往后模拟,类似于括号匹配。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
int n;
string s;
void solve()
{
    cin >> n >> s;
    stack<char> st;
    for (int i = 0; i < n; i++)
    {
        if (st.empty())
        {
            st.push(s[i]);
        }
        else
        {
            if ((s[i] == 'c' && st.top() == 'f') || (s[i] == 'b' && st.top() == 't'))
            {
                st.pop();
            }
            else
                st.push(s[i]);
        }
    }
    cout << st.size() << endl;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    // cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}

C题 tb的路径问题

思路

打表观察样例即可。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
int n;
void solve()
{
    cin >> n;
    if (n == 1)
    {
        cout << 0 << endl;
        return;
    }
    if (n == 2)
    {
        cout << n << endl;
        return;
    }
    if (n == 3)
    {
        cout << 4 << endl;
        return;
    }
    if (n % 2 == 0)
    {
        cout << 4 << endl;
    }
    else
        cout << 6 << endl;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    // cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}

D题 tb的平方问题

思路

n n n最大为 1 e 3 1e3 1e3,因此我们可以先用前缀和进行预处理,之后暴力枚举每一个连续子数组,对于和为完全平方数的连续子数组,我们对整个区间的个数加 1 1 1

因此,本题便转化为了区间加减的问题,可以使用树状数组进行求解。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 1e3 + 5;
int n, q;
int a[N], s[N];
struct BIT
{
    const static int maxnum = 1e3 + 10;
    int tree[maxnum];
    int lowbit(int x)
    {
        return (x) & (-x);
    }
    void add(int idx, int x)
    {
        for (int pos = idx; pos < maxnum; pos += lowbit(pos))
        {
            tree[pos] += x;
        }
    }
    int query(int n)
    {
        int ans = 0;
        for (int pos = n; pos; pos -= lowbit(pos))
        {
            ans += tree[pos];
        }
        return ans;
    }
    int query(int a, int b)
    {
        return query(b) - query(a - 1);
    }
    void init(int n)
    {
        for (int i = 0; i <= n + 2; i++)
            tree[i] = 0;
    }
} tree;
bool check(int x)
{
    int op = sqrt(x);
    if (op * op == x)
        return true;
    return false;
}
void solve()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        s[i] = s[i - 1] + a[i];
    }
    for (int i = 1; i <= n; i++)
    {
        for (int j = i; j <= n; j++)
        {
            int sum = s[j] - s[i - 1];
            if (check(sum))
            {
                tree.add(i, 1);
                tree.add(j + 1, -1);
            }
        }
    }
    while (q--)
    {
        int x;
        cin >> x;
        cout << tree.query(x) << endl;
    }
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    // cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}

E题 tb的数数问题

思路

找每个没有出现的数,他的倍数都是false的,其余的都是true。

时间复杂度为调和级数。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
const int N = 1e6 + 5;
int n;
int a[N];
bool st[N];
void solve()
{
    cin >> n;
    map<int, int> mp;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        mp[a[i]]++;
    }
    int ans = 0, high = *max_element(a + 1, a + 1 + n);
    for (int i = 1; i <= high; i++)
    {
        if (mp.count(i) && !st[i])
        {
            ans++;
        }
        else
        {
            for (int j = i; j <= high; j += i)
            {
                st[j] = true;
            }
        }
    }
    cout << ans << endl;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    // cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}

F题 tb的排列问题

思路

对于任意一个 b i b_{i} bi,当且仅当 p o s [ b i ] > i + w pos[b_{i}] > i + w pos[bi]>i+w时无解。

如果 b i b_{i} bi没有在数组 a a a中出现过,那么 b i b_{i} bi可以出现在 ≤ i + w \le i + w i+w的任何地方。因此我们可以使用类似于前缀和的方式, c n t [ i ] cnt[i] cnt[i]表示有多少个数字可以放到 i i i上,又因为前面已经假设放了 p r e pre pre个数字,那么当前位置就有 p r e pre pre个数字不能放了,所以答案与 c n t [ i ] − p r e cnt[i]-pre cnt[i]pre相乘。

代码

#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef long long i64;
const int N = 2e5 + 5;
template <int P>
struct MInt
{
    int x;
    constexpr MInt() : x{} {}
    constexpr MInt(i64 x) : x{norm(x % getMod())} {}

    static int Mod;
    constexpr static int getMod()
    {
        if (P > 0)
        {
            return P;
        }
        else
        {
            return Mod;
        }
    }
    constexpr static void setMod(int Mod_)
    {
        Mod = Mod_;
    }
    constexpr int norm(int x) const
    {
        if (x < 0)
        {
            x += getMod();
        }
        if (x >= getMod())
        {
            x -= getMod();
        }
        return x;
    }
    constexpr int val() const
    {
        return x;
    }
    explicit constexpr operator int() const
    {
        return x;
    }
    constexpr MInt operator-() const
    {
        MInt res;
        res.x = norm(getMod() - x);
        return res;
    }
    constexpr MInt inv() const
    {
        assert(x != 0);
        return power(*this, getMod() - 2);
    }
    constexpr MInt &operator*=(MInt rhs) &
    {
        x = 1LL * x * rhs.x % getMod();
        return *this;
    }
    constexpr MInt &operator+=(MInt rhs) &
    {
        x = norm(x + rhs.x);
        return *this;
    }
    constexpr MInt &operator-=(MInt rhs) &
    {
        x = norm(x - rhs.x);
        return *this;
    }
    constexpr MInt &operator/=(MInt rhs) &
    {
        return *this *= rhs.inv();
    }
    friend constexpr MInt operator*(MInt lhs, MInt rhs)
    {
        MInt res = lhs;
        res *= rhs;
        return res;
    }
    friend constexpr MInt operator+(MInt lhs, MInt rhs)
    {
        MInt res = lhs;
        res += rhs;
        return res;
    }
    friend constexpr MInt operator-(MInt lhs, MInt rhs)
    {
        MInt res = lhs;
        res -= rhs;
        return res;
    }
    friend constexpr MInt operator/(MInt lhs, MInt rhs)
    {
        MInt res = lhs;
        res /= rhs;
        return res;
    }
    friend constexpr std::istream &operator>>(std::istream &is, MInt &a)
    {
        i64 v;
        is >> v;
        a = MInt(v);
        return is;
    }
    friend constexpr std::ostream &operator<<(std::ostream &os, const MInt &a)
    {
        return os << a.val();
    }
    friend constexpr bool operator==(MInt lhs, MInt rhs)
    {
        return lhs.val() == rhs.val();
    }
    friend constexpr bool operator!=(MInt lhs, MInt rhs)
    {
        return lhs.val() != rhs.val();
    }
};

template <>
int MInt<0>::Mod = 998244353;

template <int V, int P>
constexpr MInt<P> CInv = MInt<P>(V).inv();

constexpr int P = 998244353;
using Z = MInt<P>;
int n, w;
int a[N], b[N];
void solve()
{
    cin >> n >> w;
    vector<int> pos(n + 1);
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        if (a[i] != -1)
        {
            pos[a[i]] = i;
        }
    }
    for (int i = 1; i <= n; i++)
    {
        cin >> b[i];
    }
    vector<int> cnt(n + 1);
    for (int i = n; i >= 1; i--)
    {
        int high = min(n, i + w);
        if (pos[b[i]] && pos[b[i]] > high)
        {
            cout << 0 << endl;
            return;
        }
        if (!pos[b[i]])
            cnt[high]++;
    }

    Z ans = 1;
    int pre = 0;
    for (int i = n; i >= 1; i--)
    {
        cnt[i - 1] += cnt[i];
        if (a[i] != -1)
            continue;
        ans *= (cnt[i] - pre);
        pre++;
    }
    cout << ans << endl;
}
signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int T = 1;
    cin >> T;
    for (int i = 1; i <= T; i++)
    {
        solve();
    }
    return 0;
}
;